﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;
using Windows.ApplicationModel.DataTransfer;
using System.Threading.Tasks;

namespace shareSourceD
{
    /// <summary>
    /// 可用于自身或导航至 Frame 内部的空白页。
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();

            DataTransferManager.GetForCurrentView().DataRequested += (a, e) =>
            {
                DataRequest r = e.Request;
                r.Data.Properties.Title = "共享文本（延迟）";
                r.Data.SetDataProvider(StandardDataFormats.Text, new DataProviderHandler(OnSetDataDelay));
            };
        }

        private async void OnSetDataDelay(DataProviderRequest request)
        {
            var def = request.GetDeferral();
            await Task.Delay(10 * 1000); //延迟
            await Dispatcher.RunAsync(Windows.UI.Core.CoreDispatcherPriority.High, () => request.SetData(txtInput.Text));
            def.Complete();
        }

        private void OnClick(object sender, RoutedEventArgs e)
        {
            DataTransferManager.ShowShareUI();
        }
    }
}
